from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Boolean, String

Fasterq_Dump_Orig_V0_1_0 = CommandToolBuilder(tool="fasterq_dump_orig", base_command=["fasterq-dump-orig"], inputs=[ToolInput(tag="in_outfile", input_type=File(optional=True), prefix="--outfile", doc=InputDocumentation(doc="output-file")), ToolInput(tag="in_outdir", input_type=Boolean(optional=True), prefix="--outdir", doc=InputDocumentation(doc="output-dir")), ToolInput(tag="in_bufsize", input_type=Boolean(optional=True), prefix="--bufsize", doc=InputDocumentation(doc="size of file-buffer dflt=1MB")), ToolInput(tag="in_cur_cache", input_type=Boolean(optional=True), prefix="--curcache", doc=InputDocumentation(doc="size of cursor-cache dflt=10MB")), ToolInput(tag="in_mem", input_type=Boolean(optional=True), prefix="--mem", doc=InputDocumentation(doc="memory limit for sorting dflt=100MB")), ToolInput(tag="in_temp", input_type=Boolean(optional=True), prefix="--temp", doc=InputDocumentation(doc="where to put temp. files dflt=curr dir")), ToolInput(tag="in_threads", input_type=Boolean(optional=True), prefix="--threads", doc=InputDocumentation(doc="how many thread dflt=6")), ToolInput(tag="in_progress", input_type=Boolean(optional=True), prefix="--progress", doc=InputDocumentation(doc="show progress")), ToolInput(tag="in_details", input_type=Boolean(optional=True), prefix="--details", doc=InputDocumentation(doc="print details")), ToolInput(tag="in_split_spot", input_type=Boolean(optional=True), prefix="--split-spot", doc=InputDocumentation(doc="split spots into reads")), ToolInput(tag="in_split_files", input_type=Boolean(optional=True), prefix="--split-files", doc=InputDocumentation(doc="write reads into different files")), ToolInput(tag="in_split_three", input_type=Boolean(optional=True), prefix="--split-3", doc=InputDocumentation(doc="writes single reads in special file")), ToolInput(tag="in_concatenate_reads", input_type=Boolean(optional=True), prefix="--concatenate-reads", doc=InputDocumentation(doc="writes whole spots into one file")), ToolInput(tag="in_stdout", input_type=Boolean(optional=True), prefix="--stdout", doc=InputDocumentation(doc="print output to stdout")), ToolInput(tag="in_force", input_type=Boolean(optional=True), prefix="--force", doc=InputDocumentation(doc="force to overwrite existing file(s)")), ToolInput(tag="in_rowid_as_name", input_type=Boolean(optional=True), prefix="--rowid-as-name", doc=InputDocumentation(doc="use row-id as name")), ToolInput(tag="in_skip_technical", input_type=Boolean(optional=True), prefix="--skip-technical", doc=InputDocumentation(doc="skip technical reads")), ToolInput(tag="in_include_technical", input_type=Boolean(optional=True), prefix="--include-technical", doc=InputDocumentation(doc="include technical reads")), ToolInput(tag="in_print_read_nr", input_type=Boolean(optional=True), prefix="--print-read-nr", doc=InputDocumentation(doc="print read-numbers")), ToolInput(tag="in_min_read_len", input_type=Boolean(optional=True), prefix="--min-read-len", doc=InputDocumentation(doc="filter by sequence-len")), ToolInput(tag="in_table", input_type=Boolean(optional=True), prefix="--table", doc=InputDocumentation(doc="which seq-table to use in case of pacbio")), ToolInput(tag="in_strict", input_type=Boolean(optional=True), prefix="--strict", doc=InputDocumentation(doc="terminate on invalid read")), ToolInput(tag="in_bases", input_type=Boolean(optional=True), prefix="--bases", doc=InputDocumentation(doc="filter by bases")), ToolInput(tag="in_append", input_type=File(optional=True), prefix="--append", doc=InputDocumentation(doc="append to output-file")), ToolInput(tag="in_ngc", input_type=File(optional=True), prefix="--ngc", doc=InputDocumentation(doc="PATH to ngc file")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="Increase the verbosity of the program\nstatus messages. Use multiple times for more\nverbosity. Negates quiet.")), ToolInput(tag="in_quiet", input_type=Boolean(optional=True), prefix="--quiet", doc=InputDocumentation(doc="Turn off all status messages for the\nprogram. Negated by verbose.")), ToolInput(tag="in_option_file", input_type=File(optional=True), prefix="--option-file", doc=InputDocumentation(doc="Read more options and parameters from the")), ToolInput(tag="in_quit_dot", input_type=String(), position=0, doc=InputDocumentation(doc="-L|--log-level <level>           Logging level as number or enum string. One ")), ToolInput(tag="in_file_dot", input_type=File(), position=0, doc=InputDocumentation(doc="fasterq-dump-orig : 2.10.9"))], outputs=[ToolOutput(tag="out_outfile", output_type=File(optional=True), selector=InputSelector(input_to_select="in_outfile", type_hint=File()), doc=OutputDocumentation(doc="output-file")), ToolOutput(tag="out_append", output_type=File(optional=True), selector=InputSelector(input_to_select="in_append", type_hint=File()), doc=OutputDocumentation(doc="append to output-file"))], container="quay.io/biocontainers/sra-tools:2.10.9--pl526haddd2b5_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Fasterq_Dump_Orig_V0_1_0().translate("wdl")

